'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TitleForm = exports.Space = exports.Divider = exports.I100Grid = exports.IGrid = exports.V100Grid = exports.VGrid = exports.H100Grid = exports.HGrid = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _styled = require('./styled');

var _styled2 = _interopRequireDefault(_styled);

var _Typography = require('@material-ui/core/Typography');

var _Typography2 = _interopRequireDefault(_Typography);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var GridCore = function GridCore(_ref) {
  var _ref$border = _ref.border,
      border = _ref$border === undefined ? false : _ref$border,
      _ref$mbetween = _ref.mbetween,
      mbetween = _ref$mbetween === undefined ? false : _ref$mbetween,
      _ref$mcenter = _ref.mcenter,
      mcenter = _ref$mcenter === undefined ? false : _ref$mcenter,
      _ref$mstart = _ref.mstart,
      mstart = _ref$mstart === undefined ? false : _ref$mstart,
      _ref$scenter = _ref.scenter,
      scenter = _ref$scenter === undefined ? false : _ref$scenter,
      _ref$sstart = _ref.sstart,
      sstart = _ref$sstart === undefined ? false : _ref$sstart,
      _ref$sstrech = _ref.sstrech,
      sstrech = _ref$sstrech === undefined ? false : _ref$sstrech;
  return {
    alignItems: scenter ? 'center' : sstart ? 'flex-start' : sstrech ? 'stretch' : 'center',
    border: border === true ? '1px solid #eee' : 'none',
    display: 'flex',
    flex: '0 1 auto',
    flexDirection: 'row',
    flexWrap: 'wrap',
    justifyContent: mcenter ? 'center' : mstart ? 'flex-start' : mbetween ? 'space-between' : 'space-between',
    marginBottom: 10,
    marginLeft: 20,
    marginRight: 20,
    marginTop: 10,
    paddingBottom: 10,
    paddingLeft: 20,
    paddingRight: 20,
    paddingTop: 10
  };
};

var HGrid = exports.HGrid = (0, _styled2.default)('div')(function (theme, props) {
  return {
    root: _extends({}, GridCore(props), {
      flex: 1
    })
  };
});

var H100Grid = exports.H100Grid = (0, _styled2.default)('div')(function (theme, props) {
  return {
    root: _extends({}, GridCore(props), {
      flex: 1,
      width: '100%'
    })
  };
});

var VGrid = exports.VGrid = (0, _styled2.default)('div')(function (theme, props) {
  return {
    root: _extends({}, GridCore(props), {
      flexDirection: 'column',
      flex: 1
    })
  };
});

var V100Grid = exports.V100Grid = (0, _styled2.default)('div')(function (theme, props) {
  return {
    root: _extends({}, GridCore(props), {
      flexDirection: 'column',
      flex: 1,
      width: '100%'
    })
  };
});

var IGridCore = function IGridCore(theme, _ref2) {
  var _ref2$border = _ref2.border,
      border = _ref2$border === undefined ? false : _ref2$border,
      _ref2$center = _ref2.center,
      center = _ref2$center === undefined ? false : _ref2$center,
      _ref2$flex = _ref2.flex,
      flex = _ref2$flex === undefined ? false : _ref2$flex,
      _ref2$start = _ref2.start,
      start = _ref2$start === undefined ? false : _ref2$start,
      _ref2$stretch = _ref2.stretch,
      stretch = _ref2$stretch === undefined ? false : _ref2$stretch;
  return {
    root: {
      alignSelf: center ? 'center' : start ? 'flex-start' : stretch ? 'stretch' : 'center',
      border: border === true ? '1px solid #eee' : 'none',
      display: 'flex',
      flex: flex !== undefined ? 1 : 0,
      marginBottom: 10,
      marginLeft: 20,
      marginRight: 20,
      marginTop: 10,
      paddingBottom: 10,
      paddingLeft: 20,
      paddingRight: 20,
      paddingTop: 10,
      top: 0
    }
  };
};

var IGrid = exports.IGrid = (0, _styled2.default)('div')(function (theme, props) {
  return IGridCore(theme, props);
});

var I100Grid = exports.I100Grid = (0, _styled2.default)('div')(function (theme, props) {
  return {
    root: _extends({}, IGridCore(theme, props), {
      flex: 1,
      width: '100%'
    })
  };
});

var Divider = exports.Divider = (0, _styled2.default)('hr')({
  root: {
    flex: 1,
    width: '100%',
    border: '1px solid #eee',
    marginBottom: 20
  }
});

var Space = exports.Space = (0, _styled2.default)('br')({
  root: {
    border: 'none',
    flex: 1,
    width: '100%',
    height: 50
  }
});

var TitleForm = exports.TitleForm = (0, _styled2.default)(_Typography2.default)(function (theme, _ref3) {
  var _ref3$h = _ref3.h1,
      h1 = _ref3$h === undefined ? false : _ref3$h,
      _ref3$h2 = _ref3.h2,
      h2 = _ref3$h2 === undefined ? false : _ref3$h2,
      _ref3$h3 = _ref3.h3,
      h3 = _ref3$h3 === undefined ? false : _ref3$h3;
  return {
    root: {
      align: 'center',
      paragraph: true,
      variant: 'headline',
      paddingBottom: 20,
      component: h1 ? 'h1' : h2 ? 'h2' : h3 ? 'h3' : undefined
    }
  };
});